SEM_WAIT(3)

NAME
sem_wait, sem_timedwait, sem_trywait - decrement (lock) a semaphore

SYNOPSIS
libpthread
#include <semaphore.h>
int
sem_wait(sem_t *sem);
int
sem_timedwait(sem_t *sem, const struct timespec *abstime);
int
sem_trywait(sem_t *sem);

DESCRIPTION
The sem_wait() function decrements (locks) the semaphore pointed to by sem, but blocks if the value of sem is zero, until the value is non-zero and the value can be decremented.

The sem_timedwait() function decrements (locks) the semaphore pointed to by sem, but blocks if the value of sem is zero, until either the value is non-zero and can be decremented or the system time specified by abstime is reached.

The sem_trywait() function decrements (locks) the semaphore pointed to by sem only if the value is non-zero. Otherwise, the semaphore is not decremented and an error is returned.

RETURN VALUES

ERRORS
sem_wait(), sem_timedwait(), and sem_trywait() will fail if:

[EINVAL]
    sem points to an invalid semaphore.

Additionally, sem_wait() and sem_timedwait() will fail if:

[EINTR]
    The call was interrupted by a signal.

Additionally, sem_timedwait() will fail if:

[EINVAL]
    abstime was NULL or specified a nanosecond value less than zero or greater than 1000 million.

[ETIMEDOUT]
    The semaphore value was zero and could not be decremented before abstime was reached.

Additionally, sem_trywait() will fail if:

[EAGAIN]
    The semaphore value was zero, and thus could not be decremented.

SEE ALSO
sem_destroy(3), sem_getvalue(3), sem_init(3), sem_open(3), sem_post(3)

STANDARDS
sem_wait(), sem_timedwait(), and sem_trywait() conform to p1003.1-2008.